/*
 Copyright (c) 2000-2001, Neil Rhodes and Julie McKeehan
   neil@pobox.com
 All rights reserved.

From the book "Palm Programming, the Developer's Guide, 2nd edition"
by O'Reilly.

Permission granted to use this file however you see fit.
*/

#define DO_NOT_ALLOW_ACCESS_TO_INTERNALS_OF_STRUCTS
#include <BuildDefines.h>
#ifdef DEBUG_BUILD
#define ERROR_CHECK_LEVEL ERROR_CHECK_FULL
#endif
#include <PalmOS.h>
#include "SunAngle_defs.h"
#include "InfoForm.h"
#include "MathLib.h"
#include "DateTime.h"
#include "TimeMgr.h"
#include "SunAngle.h"
#include "Utils.h"
#include "pdouble.h"

static
void InfoFormInit(FormPtr form)
{
  // warning-- don't do any drawing in this routine.
  // Also, don't call FrmSetFocus from here (it must be called *after*
  // FrmDrawForm)
}

static
void InfoFormDeinit(FormPtr form)
{
}


Boolean InfoFormHandleEvent(EventPtr event)
{
  Boolean handled = false;
  FormPtr form;
  FieldPtr field;
  static MemHandle contentHandle;

  form = FrmGetActiveForm();
  switch (event->eType)
  {
  case frmOpenEvent:
    InfoFormInit(form);
    WinSetDrawWindow(WinGetDisplayWindow());
//    SysCopyStringResource(str, s_Info);
    field = (FieldType *) FrmGetObjectPtr(form, FrmGetObjectIndex(form, InfoField));
//    SetFieldTextFromStr (field, str, true);

    contentHandle = DmGetResource('tSTR', s_Info);
    FldSetTextHandle(field, contentHandle);

    FrmDrawForm(form);
    // here's where you'd add a call to FrmSetFocus

    handled = true;
    break;


  case ctlSelectEvent:
  switch (event->data.ctlSelect.controlID) {
    case b_Info:
      handled = true;
      break;
    case b_Alt:
      FrmGotoForm(AltForm);
      handled = true;
      break;
    case b_Compass:
      FrmGotoForm(CompassForm);
      handled = true;
      break;
    case b_Listing:
      FrmGotoForm(ListingForm);
      handled = true;
      break;
    case b_Settings:
      FrmGotoForm(SettingsForm);
      handled = true;
      break;
    }
    break;

  case frmCloseEvent:
    field = (FieldType *) FrmGetObjectPtr(form, FrmGetObjectIndex(form, InfoField));
    FldSetTextHandle(field, NULL);
    DmReleaseResource(contentHandle);
    InfoFormDeinit(FrmGetActiveForm());
    handled = false;
    break;

  default:
    break;
  }
  return handled;
}
